/*
   Dama 1.0: Programma di Dama a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;


public class Graph extends JPanel {

private Image Pnero,Pbianco,Dnero,Dbianco;	
  protected Dama c;
  protected SBox selBox;
  private Mouse ms; 
  private Color ctrue=new Color(1.0f,1.0f,1.0f);
  private Color cfalse=new Color(0.0f,0.0f,0.0f);
  
  
  public Graph(Dama c){
  	
Pnero=Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("nero.png"));
Pbianco=Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("bianco.png"));
Dnero=Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("dnero.png"));
Dbianco=Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("dbianco.png"));

MediaTracker tracker = new MediaTracker(this);
	    
	    tracker.addImage(Pnero, 0);	
	    tracker.addImage(Pbianco, 0);
	    tracker.addImage(Dnero, 0);
	    tracker.addImage(Dbianco, 0);
try{	    
	    tracker.waitForID(0);
	}catch(Exception e){}
  	this.c=c;
  	ms=new Mouse();
  	selBox=new SBox(c);
  	
  	this.addMouseListener(ms);
  	this.addMouseMotionListener(ms);
  	}
  
  public void paintComponent(Graphics g){
   	
   	super.paintComponent(g);
   	Graphics2D g2=(Graphics2D) g;


   	

   	   if (!c.isActive()){
   	   	setFont(new Font("",Font.PLAIN,(int)((Define.QL*8+Define.SW*2)/20)));

      	g2.drawString("HA VINTO IL "+c.theWinner(),(Define.QL*8+Define.SW*2)/4,(Define.QL*8+Define.SH*2)/2);
   	}else setTav(g2);
   	
   	}
   	 
   	
   	private void setTav(Graphics2D g2){
   		int x,y,w,h;

   	for (int i=0;i<8;i++)
    for (int j=0;j<8;j++){
    	x=(i)*Define.QL+Define.SW;
    	y=(j)*Define.QL+Define.SH;
    	h=w=Define.QL;
    	
    	
        if (c.q[i][j].GetType()){
       	    g2.setColor(ctrue);
        	g2.fillRect(x,y,w,h);
        	}
        	
        else {
        	g2.setColor(cfalse);
        	g2.fillRect(x,y,w,h);
        	} 
   if (c.q[i][j].GetPCol()!=Define.VUOTO){

   int k=(Define.QL-Define.Ldef)/2;
   
   if (c.q[i][j].GetPCol()==Define.NERO){
   if (c.q[i][j].isDama())
   g2.drawImage(Dnero,x+k,y+k,this);   
   else	
   g2.drawImage(Pnero,x+k,y+k,this);
   }else{
   if (c.q[i][j].isDama())
   g2.drawImage(Dbianco,x+k,y+k,this);   
   else   	
   g2.drawImage(Pbianco,x+k,y+k,this);   
   }}
   
   }
   	

   selBox.draw(g2);
        
	
   		}
   		

   	
class Mouse implements MouseListener,MouseMotionListener
{  

   public void mouseClicked(MouseEvent event)
   { int x=(event.getX()-Define.SW)/Define.QL;
     int y=(event.getY()-Define.SH)/Define.QL;
     
    if (c.isActive()){ 
      
     c.setPos(x,y);
    if(c.isSetXY()){
       c.moveTo();
       repaint();
       }
       
     else{ 
   	
   	if (c.SelectQ(x,y)){ 
   	    selBox.enable0(x,y);
   	    repaint();
  	    }
  	}
   	}else{
   		c.reset();
   		repaint();
   		}
   	
   	}

   public void mouseMoved(MouseEvent event)
   {
    if (c.isActive()){ 
   	int x=(event.getX()-Define.SW)/Define.QL;
   	int y=(event.getY()-Define.SH)/Define.QL;
   	c.setPos(x,y);
   	if ((x>=0)&&(x<8)&&(y>=0)&&(y<8))
   	selBox.enable(x,y);
   	else selBox.disable();
   	repaint();
    }
   	} 
  
  public void mouseExited(MouseEvent event){} 
  public void mouseEntered(MouseEvent event){} 
  public void mouseDragged(MouseEvent event){}
  public void mouseReleased(MouseEvent event){}
  public void mousePressed(MouseEvent event){}

}


	}
	
	
