/*
   Dama 1.0: Programma di Dama a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import java.util.Vector;

public class Mosse{
	
	private Vector m;

    public Mosse(){
    	
    	m=new Vector(0,1);    	
    	}	 
	
	public void clear(){
		
		m.clear();
		m.trimToSize();
		}

    public Mossa getLastAndRemove(){
    	
    	if (m.isEmpty()) return null;
    	
    	Mossa last;
    	last=(Mossa) m.remove(m.size()-1);

    	return last;
    	}
   
    public Mossa getLast(){
    	
    if (m.isEmpty()) return null;
    	
    	Mossa last;
    	last=(Mossa) m.lastElement();

    	return last;
    	} 
    
    public Mossa getPLast(){
    	
    if (m.size()<2) return null;
    	
    	Mossa plast;
    	plast=(Mossa) m.elementAt(m.size()-2);

    	return plast;
    	}
    	    
    public void addMove(int i,int j,int toi,int toj,int color,int state,boolean dama){
    
    	m.add(new Mossa(i,j,toi,toj,color,state,dama));
    	
    	}

    public void addRemove(int i,int j,int color,int state,boolean dama){
    	
    	m.add(new Mossa(i,j,color,state,dama));
    	
    	}

public class Mossa{
	
	public final boolean rem,dama;
	public final int fx,fy,tx,ty,color,state;
	
	public Mossa(int i,int j,int color,int state,boolean dama){
		
		this.rem=true;
		this.fx=this.tx=i;
		this.fy=this.ty=j;
		this.color=color;
		this.state=state;
		this.dama=dama;		
		}

	public Mossa(int i,int j,int toi,int toj,int color,int state,boolean dama){
		
		this.rem=false;

		this.fx=i;
		this.fy=j;
		this.tx=toi;
		this.ty=toj;
		this.color=color;
		this.state=state;		
		this.dama=dama;
		}		
	
	
	
	}	
	
	
	}