/*
   Dama 1.0: Programma di Dama a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
public class Quadrato{
	

	private boolean type,dama,signed,bloc;
	private int col=Define.VUOTO;
    private boolean topleft,topright,bottomleft,bottomright;

    public Quadrato(boolean type){
    	this.type=type;
    	}	
	
	public boolean GetType(){return type;}
	public int GetPCol(){return col;}
	public boolean isDama(){return dama;}	
	
	public void setDama(boolean d){
		dama=d;
		} 
	public void setPCol(int col){
		this.col=col;
		}
	public void reset(){
		dama=false;
		col=Define.VUOTO;		
		}
	public void setType(boolean t){
		type=t;
		}

	public boolean isSigned(){
		return signed;
		}
		
	public boolean isBlocked(){
		return bloc;}		
		
	public void setBState(boolean b){
		bloc=b;}		
		
	
	public void reset4(){
	topleft=topright=bottomleft=bottomright=false;
	signed=false;	
	}
	
	public void setTopLeft(){
		signed=true;		
		topleft=true;
		}
	public void setTopRight(){
		signed=true;
		topright=true;
		}	
	public void setBottomLeft(){
		signed=true;
		bottomleft=true;
		}	
	public void setBottomRight(){
		signed=true;
		bottomright=true;
		}
		
   	public void unsetTopLeft(){
		topleft=false;
		if ((!topright)&&(!bottomright)&&(!bottomleft)) signed=false;
		}
	public void unsetTopRight(){
		topright=false;
		if ((!topleft)&&(!bottomright)&&(!bottomleft)) signed=false;
	    }	
	public void unsetBottomLeft(){
		bottomleft=false;
		if ((!topright)&&(!bottomright)&&(!topleft)) signed=false;
		}	
	public void unsetBottomRight(){
		bottomright=false;
		if ((!topright)&&(!topleft)&&(!bottomleft)) signed=false;
		}	
	public boolean getTopLeft(){
		return topleft;
		}
	public boolean getTopRight(){
		return topright;
		}	
	public boolean getBottomLeft(){
		return bottomleft;
		}	
	public boolean getBottomRight(){
		return bottomright;
		}
}