/*
   Dama 1.0: Programma di Dama a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.awt.geom.*;
import java.awt.*;

public class SBox{
      	
	 private Rectangle a,b,c,d;
	 private Rectangle a0,b0,c0,d0;
	 private boolean active;
	 private int l,s,bx,by;
	 private Dama m;
	
     public SBox(Dama m){
        this.m=m;
	   	l=Define.QL;
     	s=l/16; 
	   	
	   	a=new Rectangle(l,s);
     	b=new Rectangle(s,l);
       	c=new Rectangle(l,s);
       	d=new Rectangle(s,l);
	   	a0=new Rectangle(l,s);
     	b0=new Rectangle(s,l);
       	c0=new Rectangle(l,s);
       	d0=new Rectangle(s,l);   	
 		  	
     	}
	
	 public void repaint(){ 
	   	l=Define.QL;
     	s=l/16; 
	   	
	   	a=new Rectangle(l,s);
     	b=new Rectangle(s,l);
       	c=new Rectangle(l,s);
       	d=new Rectangle(s,l);

	   	a0=new Rectangle(l,s);
     	b0=new Rectangle(s,l);
       	c0=new Rectangle(l,s);
       	d0=new Rectangle(s,l);       	  
   if (m.isSetXY()){
	 	enableXY();
	 	}
	 	}
	
	 public void draw(Graphics2D g){
	 	

	 		
	 if (m.isSetXY()){
 	 	g.setColor(Color.red);	
 	 	g.fill(a0);
	 	g.fill(b0);
	 	g.fill(c0);
 	 	g.fill(d0);
 	 		}
 	 	if (active){	 			
	 if (m.isValidQ()) g.setColor(Color.blue);
   	    else g.setColor(Color.green);
    	g.fill(a);
	 	g.fill(b);
	 	g.fill(c);
 	 	g.fill(d);
 	 	

	 	}
	 } 
	 	
	 public void enable(int x,int y){
	 	active=true;

	 	a.setLocation(0,0);
	 	b.setLocation(l-s,0);
	 	c.setLocation(0,l-s);
	 	d.setLocation(0,0);
	 	
	 	a.translate(x*Define.QL+Define.SW,y*Define.QL+Define.SH);
	 	b.translate(x*Define.QL+Define.SW,y*Define.QL+Define.SH);
		c.translate(x*Define.QL+Define.SW,y*Define.QL+Define.SH);
 		d.translate(x*Define.QL+Define.SW,y*Define.QL+Define.SH);	 
 		
	 	} 
	 
 
	 public void enable0(int x, int y){
	 	
	 	bx=x;
	 	by=y;
	 	
	 	a0.setLocation(0,0);
	 	b0.setLocation(l-s,0);
	 	c0.setLocation(0,l-s);
	 	d0.setLocation(0,0);
	 	
	 	a0.translate(x*Define.QL+Define.SW,y*Define.QL+Define.SH);
	 	b0.translate(x*Define.QL+Define.SW,y*Define.QL+Define.SH);
		c0.translate(x*Define.QL+Define.SW,y*Define.QL+Define.SH);
 		d0.translate(x*Define.QL+Define.SW,y*Define.QL+Define.SH);
	 	
	 	}
	 
	 private void enableXY(){
	 	
	 	enable0(bx,by);
	 	
	 	}	    
	 
	 public void disable(){
	 	active=false;
	 	} 	
	
	 public boolean isActive(){return active;}

	}